<?php
/**
 * InlineResponse20084Content
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineResponse20084Content Class Doc Comment
 *
 * @category Class
 * @description Describes a pc component
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineResponse20084Content implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_response_200_84_content';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'inventoryNumber' => 'string',
        'componentTypeId' => 'int',
        'pcId' => 'int',
        'peripheryId' => 'int',
        'manufacturerId' => 'int',
        'type' => 'string',
        'serialNumber' => 'string',
        'megabytes' => 'int',
        'hddTypeId' => 'int',
        'scsiId' => 'string',
        'onBoard' => 'bool',
        'companyId' => 'int',
        'remark' => 'string',
        'active' => 'bool',
        'date' => 'int',
        'billingNumber' => 'string',
        'articleNumber' => 'string',
        'storageId' => 'int',
        'purchasePrice' => 'float',
        'sellingPrice' => 'float',
        'description' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'id' => null,
        'inventoryNumber' => null,
        'componentTypeId' => null,
        'pcId' => null,
        'peripheryId' => null,
        'manufacturerId' => null,
        'type' => null,
        'serialNumber' => null,
        'megabytes' => null,
        'hddTypeId' => null,
        'scsiId' => null,
        'onBoard' => null,
        'companyId' => null,
        'remark' => null,
        'active' => null,
        'date' => 'timestamp',
        'billingNumber' => null,
        'articleNumber' => null,
        'storageId' => null,
        'purchasePrice' => null,
        'sellingPrice' => null,
        'description' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'inventoryNumber' => 'inventoryNumber',
        'componentTypeId' => 'componentTypeId',
        'pcId' => 'pcId',
        'peripheryId' => 'peripheryId',
        'manufacturerId' => 'manufacturerId',
        'type' => 'type',
        'serialNumber' => 'serialNumber',
        'megabytes' => 'megabytes',
        'hddTypeId' => 'hddTypeId',
        'scsiId' => 'scsiId',
        'onBoard' => 'onBoard',
        'companyId' => 'companyId',
        'remark' => 'remark',
        'active' => 'active',
        'date' => 'date',
        'billingNumber' => 'billingNumber',
        'articleNumber' => 'articleNumber',
        'storageId' => 'storageId',
        'purchasePrice' => 'purchasePrice',
        'sellingPrice' => 'sellingPrice',
        'description' => 'description'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'inventoryNumber' => 'setInventoryNumber',
        'componentTypeId' => 'setComponentTypeId',
        'pcId' => 'setPcId',
        'peripheryId' => 'setPeripheryId',
        'manufacturerId' => 'setManufacturerId',
        'type' => 'setType',
        'serialNumber' => 'setSerialNumber',
        'megabytes' => 'setMegabytes',
        'hddTypeId' => 'setHddTypeId',
        'scsiId' => 'setScsiId',
        'onBoard' => 'setOnBoard',
        'companyId' => 'setCompanyId',
        'remark' => 'setRemark',
        'active' => 'setActive',
        'date' => 'setDate',
        'billingNumber' => 'setBillingNumber',
        'articleNumber' => 'setArticleNumber',
        'storageId' => 'setStorageId',
        'purchasePrice' => 'setPurchasePrice',
        'sellingPrice' => 'setSellingPrice',
        'description' => 'setDescription'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'inventoryNumber' => 'getInventoryNumber',
        'componentTypeId' => 'getComponentTypeId',
        'pcId' => 'getPcId',
        'peripheryId' => 'getPeripheryId',
        'manufacturerId' => 'getManufacturerId',
        'type' => 'getType',
        'serialNumber' => 'getSerialNumber',
        'megabytes' => 'getMegabytes',
        'hddTypeId' => 'getHddTypeId',
        'scsiId' => 'getScsiId',
        'onBoard' => 'getOnBoard',
        'companyId' => 'getCompanyId',
        'remark' => 'getRemark',
        'active' => 'getActive',
        'date' => 'getDate',
        'billingNumber' => 'getBillingNumber',
        'articleNumber' => 'getArticleNumber',
        'storageId' => 'getStorageId',
        'purchasePrice' => 'getPurchasePrice',
        'sellingPrice' => 'getSellingPrice',
        'description' => 'getDescription'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }


    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = $data['id'] ?? null;
        $this->container['inventoryNumber'] = $data['inventoryNumber'] ?? null;
        $this->container['componentTypeId'] = $data['componentTypeId'] ?? null;
        $this->container['pcId'] = $data['pcId'] ?? null;
        $this->container['peripheryId'] = $data['peripheryId'] ?? null;
        $this->container['manufacturerId'] = $data['manufacturerId'] ?? null;
        $this->container['type'] = $data['type'] ?? null;
        $this->container['serialNumber'] = $data['serialNumber'] ?? null;
        $this->container['megabytes'] = $data['megabytes'] ?? null;
        $this->container['hddTypeId'] = $data['hddTypeId'] ?? null;
        $this->container['scsiId'] = $data['scsiId'] ?? null;
        $this->container['onBoard'] = $data['onBoard'] ?? null;
        $this->container['companyId'] = $data['companyId'] ?? null;
        $this->container['remark'] = $data['remark'] ?? null;
        $this->container['active'] = $data['active'] ?? null;
        $this->container['date'] = $data['date'] ?? null;
        $this->container['billingNumber'] = $data['billingNumber'] ?? null;
        $this->container['articleNumber'] = $data['articleNumber'] ?? null;
        $this->container['storageId'] = $data['storageId'] ?? null;
        $this->container['purchasePrice'] = $data['purchasePrice'] ?? null;
        $this->container['sellingPrice'] = $data['sellingPrice'] ?? null;
        $this->container['description'] = $data['description'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int|null $id id of the pc / server
     *
     * @return self
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets inventoryNumber
     *
     * @return string|null
     */
    public function getInventoryNumber()
    {
        return $this->container['inventoryNumber'];
    }

    /**
     * Sets inventoryNumber
     *
     * @param string|null $inventoryNumber inventory number of this component
     *
     * @return self
     */
    public function setInventoryNumber($inventoryNumber)
    {
        $this->container['inventoryNumber'] = $inventoryNumber;

        return $this;
    }

    /**
     * Gets componentTypeId
     *
     * @return int|null
     */
    public function getComponentTypeId()
    {
        return $this->container['componentTypeId'];
    }

    /**
     * Sets componentTypeId
     *
     * @param int|null $componentTypeId id of the component type
     *
     * @return self
     */
    public function setComponentTypeId($componentTypeId)
    {
        $this->container['componentTypeId'] = $componentTypeId;

        return $this;
    }

    /**
     * Gets pcId
     *
     * @return int|null
     */
    public function getPcId()
    {
        return $this->container['pcId'];
    }

    /**
     * Sets pcId
     *
     * @param int|null $pcId the component is built into this pc (0 if the component ist not attached to a pc)
     *
     * @return self
     */
    public function setPcId($pcId)
    {
        $this->container['pcId'] = $pcId;

        return $this;
    }

    /**
     * Gets peripheryId
     *
     * @return int|null
     */
    public function getPeripheryId()
    {
        return $this->container['peripheryId'];
    }

    /**
     * Sets peripheryId
     *
     * @param int|null $peripheryId if the component is built into a periphery, here the id is given
     *
     * @return self
     */
    public function setPeripheryId($peripheryId)
    {
        $this->container['peripheryId'] = $peripheryId;

        return $this;
    }

    /**
     * Gets manufacturerId
     *
     * @return int|null
     */
    public function getManufacturerId()
    {
        return $this->container['manufacturerId'];
    }

    /**
     * Sets manufacturerId
     *
     * @param int|null $manufacturerId id of the components manufacturer
     *
     * @return self
     */
    public function setManufacturerId($manufacturerId)
    {
        $this->container['manufacturerId'] = $manufacturerId;

        return $this;
    }

    /**
     * Gets type
     *
     * @return string|null
     */
    public function getType()
    {
        return $this->container['type'];
    }

    /**
     * Sets type
     *
     * @param string|null $type type of the component. This is mostly used to \"describe\" the component in lists
     *
     * @return self
     */
    public function setType($type)
    {
        $this->container['type'] = $type;

        return $this;
    }

    /**
     * Gets serialNumber
     *
     * @return string|null
     */
    public function getSerialNumber()
    {
        return $this->container['serialNumber'];
    }

    /**
     * Sets serialNumber
     *
     * @param string|null $serialNumber serial number of the component
     *
     * @return self
     */
    public function setSerialNumber($serialNumber)
    {
        $this->container['serialNumber'] = $serialNumber;

        return $this;
    }

    /**
     * Gets megabytes
     *
     * @return int|null
     */
    public function getMegabytes()
    {
        return $this->container['megabytes'];
    }

    /**
     * Sets megabytes
     *
     * @param int|null $megabytes capcity (in megbytes), which is used to determine the size of ram or HDDs
     *
     * @return self
     */
    public function setMegabytes($megabytes)
    {
        $this->container['megabytes'] = $megabytes;

        return $this;
    }

    /**
     * Gets hddTypeId
     *
     * @return int|null
     */
    public function getHddTypeId()
    {
        return $this->container['hddTypeId'];
    }

    /**
     * Sets hddTypeId
     *
     * @param int|null $hddTypeId id of the HDD type
     *
     * @return self
     */
    public function setHddTypeId($hddTypeId)
    {
        $this->container['hddTypeId'] = $hddTypeId;

        return $this;
    }

    /**
     * Gets scsiId
     *
     * @return string|null
     */
    public function getScsiId()
    {
        return $this->container['scsiId'];
    }

    /**
     * Sets scsiId
     *
     * @param string|null $scsiId SCSI id
     *
     * @return self
     */
    public function setScsiId($scsiId)
    {
        $this->container['scsiId'] = $scsiId;

        return $this;
    }

    /**
     * Gets onBoard
     *
     * @return bool|null
     */
    public function getOnBoard()
    {
        return $this->container['onBoard'];
    }

    /**
     * Sets onBoard
     *
     * @param bool|null $onBoard if true, the component is \"onboard\"
     *
     * @return self
     */
    public function setOnBoard($onBoard)
    {
        $this->container['onBoard'] = $onBoard;

        return $this;
    }

    /**
     * Gets companyId
     *
     * @return int|null
     */
    public function getCompanyId()
    {
        return $this->container['companyId'];
    }

    /**
     * Sets companyId
     *
     * @param int|null $companyId id of the company, which this component is assigned to. Only relevant if the component is not built into a pc!
     *
     * @return self
     */
    public function setCompanyId($companyId)
    {
        $this->container['companyId'] = $companyId;

        return $this;
    }

    /**
     * Gets remark
     *
     * @return string|null
     */
    public function getRemark()
    {
        return $this->container['remark'];
    }

    /**
     * Sets remark
     *
     * @param string|null $remark remarks for this component
     *
     * @return self
     */
    public function setRemark($remark)
    {
        $this->container['remark'] = $remark;

        return $this;
    }

    /**
     * Gets active
     *
     * @return bool|null
     */
    public function getActive()
    {
        return $this->container['active'];
    }

    /**
     * Sets active
     *
     * @param bool|null $active true, if the component is active
     *
     * @return self
     */
    public function setActive($active)
    {
        $this->container['active'] = $active;

        return $this;
    }

    /**
     * Gets date
     *
     * @return int|null
     */
    public function getDate()
    {
        return $this->container['date'];
    }

    /**
     * Sets date
     *
     * @param int|null $date date when the component was purchased (or entered into the system)
     *
     * @return self
     */
    public function setDate($date)
    {
        $this->container['date'] = $date;

        return $this;
    }

    /**
     * Gets billingNumber
     *
     * @return string|null
     */
    public function getBillingNumber()
    {
        return $this->container['billingNumber'];
    }

    /**
     * Sets billingNumber
     *
     * @param string|null $billingNumber infos about the billing number which this component was purchased
     *
     * @return self
     */
    public function setBillingNumber($billingNumber)
    {
        $this->container['billingNumber'] = $billingNumber;

        return $this;
    }

    /**
     * Gets articleNumber
     *
     * @return string|null
     */
    public function getArticleNumber()
    {
        return $this->container['articleNumber'];
    }

    /**
     * Sets articleNumber
     *
     * @param string|null $articleNumber article number of the component
     *
     * @return self
     */
    public function setArticleNumber($articleNumber)
    {
        $this->container['articleNumber'] = $articleNumber;

        return $this;
    }

    /**
     * Gets storageId
     *
     * @return int|null
     */
    public function getStorageId()
    {
        return $this->container['storageId'];
    }

    /**
     * Sets storageId
     *
     * @param int|null $storageId id of the storage, the component is contained in
     *
     * @return self
     */
    public function setStorageId($storageId)
    {
        $this->container['storageId'] = $storageId;

        return $this;
    }

    /**
     * Gets purchasePrice
     *
     * @return float|null
     */
    public function getPurchasePrice()
    {
        return $this->container['purchasePrice'];
    }

    /**
     * Sets purchasePrice
     *
     * @param float|null $purchasePrice purchase price of this component
     *
     * @return self
     */
    public function setPurchasePrice($purchasePrice)
    {
        $this->container['purchasePrice'] = $purchasePrice;

        return $this;
    }

    /**
     * Gets sellingPrice
     *
     * @return float|null
     */
    public function getSellingPrice()
    {
        return $this->container['sellingPrice'];
    }

    /**
     * Sets sellingPrice
     *
     * @param float|null $sellingPrice selling price of this component
     *
     * @return self
     */
    public function setSellingPrice($sellingPrice)
    {
        $this->container['sellingPrice'] = $sellingPrice;

        return $this;
    }

    /**
     * Gets description
     *
     * @return string|null
     */
    public function getDescription()
    {
        return $this->container['description'];
    }

    /**
     * Sets description
     *
     * @param string|null $description misc. description infos for this component
     *
     * @return self
     */
    public function setDescription($description)
    {
        $this->container['description'] = $description;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


